import voxl_serial
import ctypes as ct

uint8_t = ct.c_uint8
dev = voxl_serial.VoxlSerialPort()
dev.port = '/dev/tty-slpi-7'
dev.baudrate = 420000
dev.open()

# Bootloader command 
data_out = (uint8_t * 6)()
data_out[0] = 0xEC  # ADDR -> RECEIVER
data_out[1] = 0x04  # LEN  -> 4 BYTES
data_out[2] = 0x32  # TYPE -> COMMAND
data_out[3] = 0x62  # COM1 -> 'b'
data_out[4] = 0x6C  # COM2 -> 'l'
data_out[5] = 0x0A  # CRC  ->  10

bytes_out = bytearray(data_out)

# Write command to UART port
# print(f'\nSending {len(data_out)} bytes: {list(data_out)}')
dev.write(bytes_out)
dev.close()