import voxl_serial
import ctypes as ct
import time

uint8_t = ct.c_uint8
dev = voxl_serial.VoxlSerialPort()
dev.port = '/dev/tty-slpi-7'
dev.baudrate = 420000
dev.open()

# Device Info command
data_out = (uint8_t * 7)()
data_out[0] = 0xEC  # ADDR ----> RECEIVER
data_out[1] = 0x05  # LEN  ----> 5 BYTES
data_out[2] = 0x28  # TYPE ----> DEVICE PING
data_out[3] = 0xEC  # DEST ----> RECEIVER 
data_out[4] = 0xC8  # ORIG ----> FLIGHT CONTROLLER
data_out[5] = 0xEC  # PAYLOAD -> RECEIVER
data_out[6] = 0x98  # CRC -----> 152

bytes_out = bytearray(data_out)
data = (uint8_t * 64)()

# Write command to UART port
# print(f'\nSending {len(data_out)} bytes: {list(data_out)}')
dev.write(bytes_out)

time.sleep(0.25)

# Read response 
data = dev.read(64)
dev.close()
hex_string = ' '.join([format(byte, '02x') for byte in data])

# Print the number of bytes read and hex values
print(len(data))
print(hex_string)

# Extra prints msgs useful for debugging...
# print(f"Read {len(data)} bytes: {hex_string}")
# non_zero_values = [value for value in data if value != 0]
# print(f"Decimal bytes: {non_zero_values}")
# print(f"Hex bytes: {[hex(value) for value in non_zero_values]}")
# print(f"Decoded bytes: {[chr(value) for value in non_zero_values[5:]]}")